      subroutine kinkk4(ikin,imom,ecm,m,p,x,ndim,dlips)
 
      use inprms
      use kincuts
      use ntnkin
 
      implicit none
 
      integer, parameter :: nepl=7
      integer :: ikin,imom,ndim
      real(dp) :: ecm,m(nepl),p(0:3,nepl),x(ndim),dlips,v(3),g
      real(dp), dimension(0:3) :: q1,q2,q3
      real(dp) :: sqsl1,sqsl2,sqsl3
      real(dp) :: sqsu1,sqsu2,sqsu3
      real(dp) :: sqs1,sqs2,sqs3
      real(dp) :: ds1,ds2,ds3
      real(dp) :: s1,s2,s3
      real(dp) :: dl1,dl2,dl3
 
      if (ikin <= nt82) then                                                    
       sqsl1=m(3)+m(7)                                                          
       sqsl2=m(5)+m(6)                                                          
       sqsl3=sqsl1+sqsl2                                                        
       if (imom /= 1) then                                                      
        q1=p(:,3)+p(:,7)                                                        
        q2=p(:,5)+p(:,6)                                                        
        q3=q1+q2                                                                
       end if                                                                   
       if (ikin == 149) then                                                    
       sqsu3=ecm-m(4)                                                           
       call mapbkk(imom,x(3),q3,mpi,zero,sqsl3,sqsu3,s3,sqs3,ds3)               
       sqsu2=sqs3-sqsl1                                                         
       call mapakk(imom,x(2),q2,sqscut,sqsl2,sqsu2,s2,sqs2,ds2)                 
       sqsu1=sqs3-sqs2                                                          
       call mapbkk(imom,x(1),q1,mpi,zero,sqsl1,sqsu1,s1,sqs1,ds1)               
       end if                                                                   
       if (ikin == 150) then
       sqsu3=ecm-m(4)
       call mapbkk(imom,x(3),q3,mpi,zero,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-sqsl1
       call mapbkk(imom,x(2),q2,mrho,gmrh,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs3-sqs2
       call mapbkk(imom,x(1),q1,mpi,zero,sqsl1,sqsu1,s1,sqs1,ds1)
       end if
       if (ikin == 151) then
       sqsu3=ecm-m(4)
       call mapbkk(imom,x(3),q3,mpi,zero,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-sqsl1
       call mapakk(imom,x(2),q2,sqscut,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs3-sqs2
       call mapbkk(imom,x(1),q1,mrho,gmrh,sqsl1,sqsu1,s1,sqs1,ds1)
       end if
       if (ikin == 152) then
       sqsu3=ecm-m(4)
       call mapbkk(imom,x(3),q3,mrho,gmrh,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-sqsl1
       call mapakk(imom,x(2),q2,sqscut,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs3-sqs2
       call mapbkk(imom,x(1),q1,mpi,zero,sqsl1,sqsu1,s1,sqs1,ds1)
       end if
       call kinff(imom,sqs1,m(3),m(7),x(4:5),p(:,3),p(:,7),dl1)
       call kinff(imom,sqs2,m(5),m(6),x(6:7),p(:,5),p(:,6),dl2)
       call kinff(imom,sqs3,sqs1,sqs2,x(8:9),q1,q2,dl3)
       call kinff(imom,ecm,m(4),sqs3,x(10:11),p(:,4),q3,dlips)
       dlips=dlips*ds1*ds2*ds3
     &            *dl1*dl2*dl3
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,7))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,5))
        call boost(g,v,p(:,6))
        v=q3(1:)/q3(0)
        g=q3(0)/sqs3
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,5))
        call boost(g,v,p(:,6))
       end if
      else if (ikin <= nt83) then
       sqsl1=m(5)+m(6)
       sqsl2=m(3)+sqsl1
       sqsl3=sqsl2+m(7)
       if (imom /= 1) then
        q1=p(:,5)+p(:,6)
        q2=p(:,3)+q1
        q3=q2+p(:,7)
       end if
       if (ikin == 153) then
       sqsu3=ecm-m(4)
       call mapbkk(imom,x(3),q3,mpi,zero,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(7)
       ds2=(sqsu2-sqsl2)*(sqsu2+sqsl2)
       if (imom == 1) then
        s2=ds2*x(2)+sqsl2*sqsl2
       else
        s2=(q2(0)-q2(3))*(q2(0)+q2(3))-q2(1)*q2(1)-q2(2)*q2(2)
       end if
       sqs2=sqrt(s2)
       sqsu1=sqs2-m(3)
       call mapakk(imom,x(1),q1,sqscut,sqsl1,sqsu1,s1,sqs1,ds1)
       end if
       if (ikin == 154) then
       sqsu3=ecm-m(4)
       call mapbkk(imom,x(3),q3,mpi,zero,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(7)
       ds2=(sqsu2-sqsl2)*(sqsu2+sqsl2)
       if (imom == 1) then
        s2=ds2*x(2)+sqsl2*sqsl2
       else
        s2=(q2(0)-q2(3))*(q2(0)+q2(3))-q2(1)*q2(1)-q2(2)*q2(2)
       end if
       sqs2=sqrt(s2)
       sqsu1=sqs2-m(3)
       call mapbkk(imom,x(1),q1,mrho,gmrh,sqsl1,sqsu1,s1,sqs1,ds1)
       end if
       call kinff(imom,sqs1,m(5),m(6),x(4:5),p(:,5),p(:,6),dl1)
       call kinff(imom,sqs2,m(3),sqs1,x(6:7),p(:,3),q1,dl2)
       call kinff(imom,sqs3,sqs2,m(7),x(8:9),q2,p(:,7),dl3)
       call kinff(imom,ecm,m(4),sqs3,x(10:11),p(:,4),q3,dlips)
       dlips=dlips*ds1*ds2*ds3
     &            *dl1*dl2*dl3
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,5))
        call boost(g,v,p(:,6))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,5))
        call boost(g,v,p(:,6))
        v=q3(1:)/q3(0)
        g=q3(0)/sqs3
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,5))
        call boost(g,v,p(:,6))
        call boost(g,v,p(:,7))
       end if
      else if (ikin <= nt84) then
       sqsl1=m(5)+m(6)
       sqsl2=m(3)+sqsl1
       sqsl3=sqsl2+m(7)
       if (imom /= 1) then
        q1=p(:,5)+p(:,6)
        q2=p(:,3)+q1
        q3=q2+p(:,7)
       end if
       if (ikin == 155) then
       sqsu3=ecm-m(4)
       call mapbkk(imom,x(3),q3,mpi,zero,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(7)
       call mapbkk(imom,x(2),q2,mpi,zero,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs2-m(3)
       call mapakk(imom,x(1),q1,sqscut,sqsl1,sqsu1,s1,sqs1,ds1)
       end if
       if (ikin == 156) then
       sqsu3=ecm-m(4)
       call mapbkk(imom,x(3),q3,mpi,zero,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(7)
       call mapbkk(imom,x(2),q2,mrho,gmrh,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs2-m(3)
       call mapakk(imom,x(1),q1,sqscut,sqsl1,sqsu1,s1,sqs1,ds1)
       end if
       if (ikin == 157) then
       sqsu3=ecm-m(4)
       call mapbkk(imom,x(3),q3,mpi,zero,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(7)
       call mapbkk(imom,x(2),q2,mpi,zero,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs2-m(3)
       call mapbkk(imom,x(1),q1,mrho,gmrh,sqsl1,sqsu1,s1,sqs1,ds1)
       end if
       if (ikin == 158) then
       sqsu3=ecm-m(4)
       call mapbkk(imom,x(3),q3,mrho,gmrh,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(7)
       call mapbkk(imom,x(2),q2,mpi,zero,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs2-m(3)
       call mapakk(imom,x(1),q1,sqscut,sqsl1,sqsu1,s1,sqs1,ds1)
       end if
       if (ikin == 159) then
       sqsu3=ecm-m(4)
       call mapbkk(imom,x(3),q3,mrho,gmrh,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(7)
       call mapbkk(imom,x(2),q2,mpi,zero,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs2-m(3)
       call mapbkk(imom,x(1),q1,mrho,gmrh,sqsl1,sqsu1,s1,sqs1,ds1)
       end if
       call kinff(imom,sqs1,m(5),m(6),x(4:5),p(:,5),p(:,6),dl1)
       call kinff(imom,sqs2,m(3),sqs1,x(6:7),p(:,3),q1,dl2)
       call kinff(imom,sqs3,sqs2,m(7),x(8:9),q2,p(:,7),dl3)
       call kinff(imom,ecm,m(4),sqs3,x(10:11),p(:,4),q3,dlips)
       dlips=dlips*ds1*ds2*ds3
     &            *dl1*dl2*dl3
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,5))
        call boost(g,v,p(:,6))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,5))
        call boost(g,v,p(:,6))
        v=q3(1:)/q3(0)
        g=q3(0)/sqs3
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,5))
        call boost(g,v,p(:,6))
        call boost(g,v,p(:,7))
       end if
      else if (ikin <= nt85) then
       sqsl1=m(5)+m(6)
       sqsl2=m(3)+sqsl1
       sqsl3=m(4)+m(7)
       if (imom /= 1) then
        q1=p(:,5)+p(:,6)
        q2=p(:,3)+q1
        q3=p(:,4)+p(:,7)
       end if
       if (ikin == 160) then
       sqsu3=ecm-sqsl2
       call mapbkk(imom,x(3),q3,mpi,zero,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=ecm-sqs3
       call mapbkk(imom,x(2),q2,mpi,zero,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs2-m(3)
       call mapakk(imom,x(1),q1,sqscut,sqsl1,sqsu1,s1,sqs1,ds1)
       end if
       if (ikin == 161) then
       sqsu3=ecm-sqsl2
       call mapbkk(imom,x(3),q3,mpi,zero,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=ecm-sqs3
       call mapbkk(imom,x(2),q2,mpi,zero,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs2-m(3)
       call mapbkk(imom,x(1),q1,mrho,gmrh,sqsl1,sqsu1,s1,sqs1,ds1)
       end if
       call kinff(imom,sqs1,m(5),m(6),x(4:5),p(:,5),p(:,6),dl1)
       call kinff(imom,sqs2,m(3),sqs1,x(6:7),p(:,3),q1,dl2)
       call kinff(imom,sqs3,m(4),m(7),x(8:9),p(:,4),p(:,7),dl3)
       call kinff(imom,ecm,sqs2,sqs3,x(10:11),q2,q3,dlips)
       dlips=dlips*ds1*ds2*ds3
     &            *dl1*dl2*dl3
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,5))
        call boost(g,v,p(:,6))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,5))
        call boost(g,v,p(:,6))
        v=q3(1:)/q3(0)
        g=q3(0)/sqs3
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,7))
       end if
      else if (ikin <= nt86) then
       sqsl1=m(4)+m(7)
       sqsl2=m(5)+m(6)
       sqsl3=m(3)+sqsl2
       if (imom /= 1) then
        q1=p(:,4)+p(:,7)
        q2=p(:,5)+p(:,6)
        q3=p(:,3)+q2
       end if
       if (ikin == 162) then
       sqsu1=ecm-sqsl3
       call mapbkk(imom,x(1),q1,mpi,zero,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu3=ecm-sqs1
       call mapbkk(imom,x(3),q3,mpi,zero,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(3)
       call mapakk(imom,x(2),q2,sqscut,sqsl2,sqsu2,s2,sqs2,ds2)
       end if
       if (ikin == 163) then
       sqsu1=ecm-sqsl3
       call mapbkk(imom,x(1),q1,mpi,zero,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu3=ecm-sqs1
       call mapbkk(imom,x(3),q3,mpi,zero,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(3)
       call mapbkk(imom,x(2),q2,mrho,gmrh,sqsl2,sqsu2,s2,sqs2,ds2)
       end if
       call kinff(imom,sqs1,m(4),m(7),x(4:5),p(:,4),p(:,7),dl1)
       call kinff(imom,sqs2,m(5),m(6),x(6:7),p(:,5),p(:,6),dl2)
       call kinff(imom,sqs3,m(3),sqs2,x(8:9),p(:,3),q2,dl3)
       call kinff(imom,ecm,sqs1,sqs3,x(10:11),q1,q3,dlips)
       dlips=dlips*ds1*ds2*ds3
     &            *dl1*dl2*dl3
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,7))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,5))
        call boost(g,v,p(:,6))
        v=q3(1:)/q3(0)
        g=q3(0)/sqs3
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,5))
        call boost(g,v,p(:,6))
       end if
      else if (ikin <= nt87) then
       sqsl1=m(3)+m(7)
       sqsl2=sqsl1+m(5)
       sqsl3=sqsl2+m(6)
       if (imom /= 1) then
        q1=p(:,3)+p(:,7)
        q2=q1+p(:,5)
        q3=q2+p(:,6)
       end if
       if (ikin == 164) then
       sqsu3=ecm-m(4)
       call mapbkk(imom,x(3),q3,mpi,zero,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(6)
       call mapakk(imom,x(2),q2,sqscut,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs2-m(5)
       call mapbkk(imom,x(1),q1,mrho,gmrh,sqsl1,sqsu1,s1,sqs1,ds1)
       end if
       if (ikin == 165) then
       sqsu3=ecm-m(4)
       call mapbkk(imom,x(3),q3,mrho,gmrh,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(6)
       call mapakk(imom,x(2),q2,sqscut,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs2-m(5)
       call mapbkk(imom,x(1),q1,mrho,gmrh,sqsl1,sqsu1,s1,sqs1,ds1)
       end if
       call kinff(imom,sqs1,m(3),m(7),x(4:5),p(:,3),p(:,7),dl1)
       call kinff(imom,sqs2,sqs1,m(5),x(6:7),q1,p(:,5),dl2)
       call kinff(imom,sqs3,sqs2,m(6),x(8:9),q2,p(:,6),dl3)
       call kinff(imom,ecm,m(4),sqs3,x(10:11),p(:,4),q3,dlips)
       dlips=dlips*ds1*ds2*ds3
     &            *dl1*dl2*dl3
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,7))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,5))
        v=q3(1:)/q3(0)
        g=q3(0)/sqs3
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,5))
        call boost(g,v,p(:,6))
       end if
      else if (ikin <= nt88) then
       sqsl1=m(5)+m(7)
       sqsl2=m(3)+sqsl1
       sqsl3=sqsl2+m(6)
       if (imom /= 1) then
        q1=p(:,5)+p(:,7)
        q2=p(:,3)+q1
        q3=q2+p(:,6)
       end if
       if (ikin == 166) then
       sqsu3=ecm-m(4)
       call mapbkk(imom,x(3),q3,mpi,zero,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(6)
       call mapakk(imom,x(2),q2,sqscut,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs2-m(3)
       call mapbkk(imom,x(1),q1,mrho,gmrh,sqsl1,sqsu1,s1,sqs1,ds1)
       end if
       if (ikin == 167) then
       sqsu3=ecm-m(4)
       call mapbkk(imom,x(3),q3,mrho,gmrh,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(6)
       call mapakk(imom,x(2),q2,sqscut,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs2-m(3)
       call mapbkk(imom,x(1),q1,mrho,gmrh,sqsl1,sqsu1,s1,sqs1,ds1)
       end if
       call kinff(imom,sqs1,m(5),m(7),x(4:5),p(:,5),p(:,7),dl1)
       call kinff(imom,sqs2,m(3),sqs1,x(6:7),p(:,3),q1,dl2)
       call kinff(imom,sqs3,sqs2,m(6),x(8:9),q2,p(:,6),dl3)
       call kinff(imom,ecm,m(4),sqs3,x(10:11),p(:,4),q3,dlips)
       dlips=dlips*ds1*ds2*ds3
     &            *dl1*dl2*dl3
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,5))
        call boost(g,v,p(:,7))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,5))
        call boost(g,v,p(:,7))
        v=q3(1:)/q3(0)
        g=q3(0)/sqs3
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,5))
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,6))
       end if
      else if (ikin <= nt89) then
       sqsl1=m(7)+m(6)
       sqsl2=m(4)+m(5)
       sqsl3=m(3)+sqsl2
       if (imom /= 1) then
        q1=p(:,7)+p(:,6)
        q2=p(:,4)+p(:,5)
        q3=p(:,3)+q2
       end if
       if (ikin == 168) then
       sqsu1=ecm-sqsl3
       call mapbkk(imom,x(1),q1,mpi,zero,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu3=ecm-sqs1
       call mapbkk(imom,x(3),q3,mpi,zero,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(3)
       call mapakk(imom,x(2),q2,sqscut,sqsl2,sqsu2,s2,sqs2,ds2)
       end if
       if (ikin == 169) then
       sqsu1=ecm-sqsl3
       call mapbkk(imom,x(1),q1,mpi,zero,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu3=ecm-sqs1
       call mapbkk(imom,x(3),q3,mpi,zero,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(3)
       call mapbkk(imom,x(2),q2,mrho,gmrh,sqsl2,sqsu2,s2,sqs2,ds2)
       end if
       if (ikin == 170) then
       sqsu1=ecm-sqsl3
       call mapbkk(imom,x(1),q1,mrho,gmrh,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu3=ecm-sqs1
       call mapbkk(imom,x(3),q3,mrho,gmrh,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(3)
       call mapakk(imom,x(2),q2,sqscut,sqsl2,sqsu2,s2,sqs2,ds2)
       end if
       call kinff(imom,sqs1,m(7),m(6),x(4:5),p(:,7),p(:,6),dl1)
       call kinff(imom,sqs2,m(4),m(5),x(6:7),p(:,4),p(:,5),dl2)
       call kinff(imom,sqs3,m(3),sqs2,x(8:9),p(:,3),q2,dl3)
       call kinff(imom,ecm,sqs1,sqs3,x(10:11),q1,q3,dlips)
       dlips=dlips*ds1*ds2*ds3
     &            *dl1*dl2*dl3
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,6))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,5))
        v=q3(1:)/q3(0)
        g=q3(0)/sqs3
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,5))
       end if
      else if (ikin <= nt91) then
       sqsl1=m(6)+m(7)
       sqsl2=m(4)+m(5)
       sqsl3=m(3)+sqsl2
       if (imom /= 1) then
        q1=p(:,6)+p(:,7)
        q2=p(:,4)+p(:,5)
        q3=p(:,3)+q2
       end if
       if (ikin == 171) then
       sqsu1=ecm-sqsl3
       call mapbkk(imom,x(1),q1,mpi,zero,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu3=ecm-sqs1
       call mapbkk(imom,x(3),q3,mpi,zero,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(3)
       call mapakk(imom,x(2),q2,sqscut,sqsl2,sqsu2,s2,sqs2,ds2)
       end if
       if (ikin == 172) then
       sqsu1=ecm-sqsl3
       call mapbkk(imom,x(1),q1,mpi,zero,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu3=ecm-sqs1
       call mapbkk(imom,x(3),q3,mpi,zero,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(3)
       call mapbkk(imom,x(2),q2,mrho,gmrh,sqsl2,sqsu2,s2,sqs2,ds2)
       end if
       if (ikin == 173) then
       sqsu1=ecm-sqsl3
       call mapbkk(imom,x(1),q1,mpi,zero,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu3=ecm-sqs1
       call mapbkk(imom,x(3),q3,mrho,gmrh,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(3)
       call mapakk(imom,x(2),q2,sqscut,sqsl2,sqsu2,s2,sqs2,ds2)
       end if
       if (ikin == 174) then
       sqsu1=ecm-sqsl3
       call mapbkk(imom,x(1),q1,mrho,gmrh,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu3=ecm-sqs1
       call mapbkk(imom,x(3),q3,mpi,zero,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(3)
       call mapakk(imom,x(2),q2,sqscut,sqsl2,sqsu2,s2,sqs2,ds2)
       end if
       if (ikin == 175) then
       sqsu1=ecm-sqsl3
       call mapbkk(imom,x(1),q1,mrho,gmrh,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu3=ecm-sqs1
       call mapbkk(imom,x(3),q3,mpi,zero,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(3)
       call mapbkk(imom,x(2),q2,mrho,gmrh,sqsl2,sqsu2,s2,sqs2,ds2)
       end if
       call kinff(imom,sqs1,m(6),m(7),x(4:5),p(:,6),p(:,7),dl1)
       call kinff(imom,sqs2,m(4),m(5),x(6:7),p(:,4),p(:,5),dl2)
       call kinff(imom,sqs3,m(3),sqs2,x(8:9),p(:,3),q2,dl3)
       call kinff(imom,ecm,sqs1,sqs3,x(10:11),q1,q3,dlips)
       dlips=dlips*ds1*ds2*ds3
     &            *dl1*dl2*dl3
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,6))
        call boost(g,v,p(:,7))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,5))
        v=q3(1:)/q3(0)
        g=q3(0)/sqs3
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,5))
       end if
      else if (ikin <= nt92) then
       sqsl1=m(6)+m(7)
       sqsl2=m(4)+m(5)
       sqsl3=m(3)+sqsl2
       if (imom /= 1) then
        q1=p(:,6)+p(:,7)
        q2=p(:,4)+p(:,5)
        q3=p(:,3)+q2
       end if
       if (ikin == 176) then
       sqsu1=ecm-sqsl3
       call mapbkk(imom,x(1),q1,mrho,gmrh,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu3=ecm-sqs1
       call mapbkk(imom,x(3),q3,mrho,gmrh,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(3)
       call mapakk(imom,x(2),q2,sqscut,sqsl2,sqsu2,s2,sqs2,ds2)
       end if
       call kinff(imom,sqs1,m(6),m(7),x(4:5),p(:,6),p(:,7),dl1)
       call kinff(imom,sqs2,m(4),m(5),x(6:7),p(:,4),p(:,5),dl2)
       call kinff(imom,sqs3,m(3),sqs2,x(8:9),p(:,3),q2,dl3)
       call kinff(imom,ecm,sqs1,sqs3,x(10:11),q1,q3,dlips)
       dlips=dlips*ds1*ds2*ds3
     &            *dl1*dl2*dl3
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,6))
        call boost(g,v,p(:,7))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,5))
        v=q3(1:)/q3(0)
        g=q3(0)/sqs3
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,5))
       end if
      else if (ikin <= nt94) then
       sqsl1=m(3)+m(6)
       sqsl2=m(4)+m(7)
       sqsl3=sqsl2+m(5)
       if (imom /= 1) then
        q1=p(:,3)+p(:,6)
        q2=p(:,4)+p(:,7)
        q3=q2+p(:,5)
       end if
       if (ikin == 177) then
       sqsu1=ecm-sqsl3
       call mapakk(imom,x(1),q1,sqscut,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu3=ecm-sqs1
       call mapakk(imom,x(3),q3,sqscut,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(5)
       call mapbkk(imom,x(2),q2,mpi,zero,sqsl2,sqsu2,s2,sqs2,ds2)
       end if
       if (ikin == 178) then
       sqsu1=ecm-sqsl3
       call mapakk(imom,x(1),q1,sqscut,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu3=ecm-sqs1
       call mapbkk(imom,x(3),q3,mrho,gmrh,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(5)
       call mapbkk(imom,x(2),q2,mpi,zero,sqsl2,sqsu2,s2,sqs2,ds2)
       end if
       if (ikin == 179) then
       sqsu1=ecm-sqsl3
       call mapbkk(imom,x(1),q1,mrho,gmrh,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu3=ecm-sqs1
       call mapakk(imom,x(3),q3,sqscut,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(5)
       call mapbkk(imom,x(2),q2,mpi,zero,sqsl2,sqsu2,s2,sqs2,ds2)
       end if
       if (ikin == 180) then
       sqsu1=ecm-sqsl3
       call mapbkk(imom,x(1),q1,mrho,gmrh,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu3=ecm-sqs1
       call mapbkk(imom,x(3),q3,mrho,gmrh,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(5)
       call mapbkk(imom,x(2),q2,mpi,zero,sqsl2,sqsu2,s2,sqs2,ds2)
       end if
       call kinff(imom,sqs1,m(3),m(6),x(4:5),p(:,3),p(:,6),dl1)
       call kinff(imom,sqs2,m(4),m(7),x(6:7),p(:,4),p(:,7),dl2)
       call kinff(imom,sqs3,sqs2,m(5),x(8:9),q2,p(:,5),dl3)
       call kinff(imom,ecm,sqs1,sqs3,x(10:11),q1,q3,dlips)
       dlips=dlips*ds1*ds2*ds3
     &            *dl1*dl2*dl3
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,6))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,7))
        v=q3(1:)/q3(0)
        g=q3(0)/sqs3
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,5))
       end if
      else if (ikin <= nt95) then
       sqsl1=m(3)+m(6)
       sqsl2=m(5)+m(7)
       sqsl3=m(4)+sqsl2
       if (imom /= 1) then
        q1=p(:,3)+p(:,6)
        q2=p(:,5)+p(:,7)
        q3=p(:,4)+q2
       end if
       if (ikin == 181) then
       sqsu1=ecm-sqsl3
       call mapakk(imom,x(1),q1,sqscut,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu3=ecm-sqs1
       call mapakk(imom,x(3),q3,sqscut,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(4)
       call mapbkk(imom,x(2),q2,mpi,zero,sqsl2,sqsu2,s2,sqs2,ds2)
       end if
       if (ikin == 182) then
       sqsu1=ecm-sqsl3
       call mapakk(imom,x(1),q1,sqscut,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu3=ecm-sqs1
       call mapbkk(imom,x(3),q3,mrho,gmrh,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(4)
       call mapbkk(imom,x(2),q2,mpi,zero,sqsl2,sqsu2,s2,sqs2,ds2)
       end if
       if (ikin == 183) then
       sqsu1=ecm-sqsl3
       call mapbkk(imom,x(1),q1,mrho,gmrh,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu3=ecm-sqs1
       call mapakk(imom,x(3),q3,sqscut,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(4)
       call mapbkk(imom,x(2),q2,mpi,zero,sqsl2,sqsu2,s2,sqs2,ds2)
       end if
       if (ikin == 184) then
       sqsu1=ecm-sqsl3
       call mapbkk(imom,x(1),q1,mrho,gmrh,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu3=ecm-sqs1
       call mapbkk(imom,x(3),q3,mrho,gmrh,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(4)
       call mapbkk(imom,x(2),q2,mpi,zero,sqsl2,sqsu2,s2,sqs2,ds2)
       end if
       call kinff(imom,sqs1,m(3),m(6),x(4:5),p(:,3),p(:,6),dl1)
       call kinff(imom,sqs2,m(5),m(7),x(6:7),p(:,5),p(:,7),dl2)
       call kinff(imom,sqs3,m(4),sqs2,x(8:9),p(:,4),q2,dl3)
       call kinff(imom,ecm,sqs1,sqs3,x(10:11),q1,q3,dlips)
       dlips=dlips*ds1*ds2*ds3
     &            *dl1*dl2*dl3
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,6))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,5))
        call boost(g,v,p(:,7))
        v=q3(1:)/q3(0)
        g=q3(0)/sqs3
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,5))
        call boost(g,v,p(:,7))
       end if
      else if (ikin <= nt96) then
       sqsl1=m(4)+m(5)
       sqsl2=sqsl1+m(7)
       sqsl3=m(3)+sqsl2
       if (imom /= 1) then
        q1=p(:,4)+p(:,5)
        q2=q1+p(:,7)
        q3=p(:,3)+q2
       end if
       if (ikin == 185) then
       sqsu3=ecm-m(6)
       call mapbkk(imom,x(3),q3,mpi,zero,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(3)
       call mapakk(imom,x(2),q2,sqscut,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs2-m(7)
       ds1=(sqsu1-sqsl1)*(sqsu1+sqsl1)
       if (imom == 1) then
        s1=ds1*x(1)+sqsl1*sqsl1
       else
        s1=(q1(0)-q1(3))*(q1(0)+q1(3))-q1(1)*q1(1)-q1(2)*q1(2)
       end if
       sqs1=sqrt(s1)
       end if
       if (ikin == 186) then
       sqsu3=ecm-m(6)
       call mapbkk(imom,x(3),q3,mpi,zero,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(3)
       call mapbkk(imom,x(2),q2,mrho,gmrh,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs2-m(7)
       ds1=(sqsu1-sqsl1)*(sqsu1+sqsl1)
       if (imom == 1) then
        s1=ds1*x(1)+sqsl1*sqsl1
       else
        s1=(q1(0)-q1(3))*(q1(0)+q1(3))-q1(1)*q1(1)-q1(2)*q1(2)
       end if
       sqs1=sqrt(s1)
       end if
       if (ikin == 187) then
       sqsu3=ecm-m(6)
       call mapbkk(imom,x(3),q3,mrho,gmrh,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(3)
       call mapakk(imom,x(2),q2,sqscut,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs2-m(7)
       ds1=(sqsu1-sqsl1)*(sqsu1+sqsl1)
       if (imom == 1) then
        s1=ds1*x(1)+sqsl1*sqsl1
       else
        s1=(q1(0)-q1(3))*(q1(0)+q1(3))-q1(1)*q1(1)-q1(2)*q1(2)
       end if
       sqs1=sqrt(s1)
       end if
       call kinff(imom,sqs1,m(4),m(5),x(4:5),p(:,4),p(:,5),dl1)
       call kinff(imom,sqs2,sqs1,m(7),x(6:7),q1,p(:,7),dl2)
       call kinff(imom,sqs3,m(3),sqs2,x(8:9),p(:,3),q2,dl3)
       call kinff(imom,ecm,m(6),sqs3,x(10:11),p(:,6),q3,dlips)
       dlips=dlips*ds1*ds2*ds3
     &            *dl1*dl2*dl3
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,5))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,5))
        call boost(g,v,p(:,7))
        v=q3(1:)/q3(0)
        g=q3(0)/sqs3
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,5))
        call boost(g,v,p(:,7))
       end if
      else if (ikin <= nt97) then
       sqsl1=m(3)+m(7)
       sqsl2=m(4)+m(5)
       sqsl3=sqsl1+sqsl2
       if (imom /= 1) then
        q1=p(:,3)+p(:,7)
        q2=p(:,4)+p(:,5)
        q3=q1+q2
       end if
       if (ikin == 188) then
       sqsu3=ecm-m(6)
       call mapbkk(imom,x(3),q3,mpi,zero,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-sqsl1
       call mapakk(imom,x(2),q2,sqscut,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs3-sqs2
       call mapbkk(imom,x(1),q1,mpi,zero,sqsl1,sqsu1,s1,sqs1,ds1)
       end if
       if (ikin == 189) then
       sqsu3=ecm-m(6)
       call mapbkk(imom,x(3),q3,mpi,zero,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-sqsl1
       call mapbkk(imom,x(2),q2,mrho,gmrh,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs3-sqs2
       call mapbkk(imom,x(1),q1,mpi,zero,sqsl1,sqsu1,s1,sqs1,ds1)
       end if
       if (ikin == 190) then
       sqsu3=ecm-m(6)
       call mapbkk(imom,x(3),q3,mpi,zero,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-sqsl1
       call mapakk(imom,x(2),q2,sqscut,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs3-sqs2
       call mapbkk(imom,x(1),q1,mrho,gmrh,sqsl1,sqsu1,s1,sqs1,ds1)
       end if
       if (ikin == 191) then
       sqsu3=ecm-m(6)
       call mapbkk(imom,x(3),q3,mrho,gmrh,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-sqsl1
       call mapakk(imom,x(2),q2,sqscut,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs3-sqs2
       call mapbkk(imom,x(1),q1,mpi,zero,sqsl1,sqsu1,s1,sqs1,ds1)
       end if
       call kinff(imom,sqs1,m(3),m(7),x(4:5),p(:,3),p(:,7),dl1)
       call kinff(imom,sqs2,m(4),m(5),x(6:7),p(:,4),p(:,5),dl2)
       call kinff(imom,sqs3,sqs1,sqs2,x(8:9),q1,q2,dl3)
       call kinff(imom,ecm,m(6),sqs3,x(10:11),p(:,6),q3,dlips)
       dlips=dlips*ds1*ds2*ds3
     &            *dl1*dl2*dl3
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,7))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,5))
        v=q3(1:)/q3(0)
        g=q3(0)/sqs3
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,5))
       end if
      else if (ikin <= nt98) then
       sqsl1=m(4)+m(5)
       sqsl2=m(3)+sqsl1
       sqsl3=sqsl2+m(7)
       if (imom /= 1) then
        q1=p(:,4)+p(:,5)
        q2=p(:,3)+q1
        q3=q2+p(:,7)
       end if
       if (ikin == 192) then
       sqsu3=ecm-m(6)
       call mapbkk(imom,x(3),q3,mpi,zero,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(7)
       ds2=(sqsu2-sqsl2)*(sqsu2+sqsl2)
       if (imom == 1) then
        s2=ds2*x(2)+sqsl2*sqsl2
       else
        s2=(q2(0)-q2(3))*(q2(0)+q2(3))-q2(1)*q2(1)-q2(2)*q2(2)
       end if
       sqs2=sqrt(s2)
       sqsu1=sqs2-m(3)
       call mapakk(imom,x(1),q1,sqscut,sqsl1,sqsu1,s1,sqs1,ds1)
       end if
       if (ikin == 193) then
       sqsu3=ecm-m(6)
       call mapbkk(imom,x(3),q3,mpi,zero,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(7)
       ds2=(sqsu2-sqsl2)*(sqsu2+sqsl2)
       if (imom == 1) then
        s2=ds2*x(2)+sqsl2*sqsl2
       else
        s2=(q2(0)-q2(3))*(q2(0)+q2(3))-q2(1)*q2(1)-q2(2)*q2(2)
       end if
       sqs2=sqrt(s2)
       sqsu1=sqs2-m(3)
       call mapbkk(imom,x(1),q1,mrho,gmrh,sqsl1,sqsu1,s1,sqs1,ds1)
       end if
       call kinff(imom,sqs1,m(4),m(5),x(4:5),p(:,4),p(:,5),dl1)
       call kinff(imom,sqs2,m(3),sqs1,x(6:7),p(:,3),q1,dl2)
       call kinff(imom,sqs3,sqs2,m(7),x(8:9),q2,p(:,7),dl3)
       call kinff(imom,ecm,m(6),sqs3,x(10:11),p(:,6),q3,dlips)
       dlips=dlips*ds1*ds2*ds3
     &            *dl1*dl2*dl3
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,5))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,5))
        v=q3(1:)/q3(0)
        g=q3(0)/sqs3
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,5))
        call boost(g,v,p(:,7))
       end if
      else if (ikin <= nt99) then
       sqsl1=m(4)+m(7)
       sqsl2=sqsl1+m(6)
       sqsl3=sqsl2+m(5)
       if (imom /= 1) then
        q1=p(:,4)+p(:,7)
        q2=q1+p(:,6)
        q3=q2+p(:,5)
       end if
       if (ikin == 194) then
       sqsu3=ecm-m(3)
       call mapbkk(imom,x(3),q3,mpi,zero,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(5)
       call mapakk(imom,x(2),q2,sqscut,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs2-m(6)
       call mapbkk(imom,x(1),q1,mrho,gmrh,sqsl1,sqsu1,s1,sqs1,ds1)
       end if
       if (ikin == 195) then
       sqsu3=ecm-m(3)
       call mapbkk(imom,x(3),q3,mrho,gmrh,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(5)
       call mapakk(imom,x(2),q2,sqscut,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs2-m(6)
       call mapbkk(imom,x(1),q1,mrho,gmrh,sqsl1,sqsu1,s1,sqs1,ds1)
       end if
       call kinff(imom,sqs1,m(4),m(7),x(4:5),p(:,4),p(:,7),dl1)
       call kinff(imom,sqs2,sqs1,m(6),x(6:7),q1,p(:,6),dl2)
       call kinff(imom,sqs3,sqs2,m(5),x(8:9),q2,p(:,5),dl3)
       call kinff(imom,ecm,m(3),sqs3,x(10:11),p(:,3),q3,dlips)
       dlips=dlips*ds1*ds2*ds3
     &            *dl1*dl2*dl3
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,7))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,6))
        v=q3(1:)/q3(0)
        g=q3(0)/sqs3
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,6))
        call boost(g,v,p(:,5))
       end if
      else if (ikin <= nt100) then
       sqsl1=m(6)+m(7)
       sqsl2=m(4)+sqsl1
       sqsl3=sqsl2+m(5)
       if (imom /= 1) then
        q1=p(:,6)+p(:,7)
        q2=p(:,4)+q1
        q3=q2+p(:,5)
       end if
       if (ikin == 196) then
       sqsu3=ecm-m(3)
       call mapbkk(imom,x(3),q3,mpi,zero,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(5)
       call mapakk(imom,x(2),q2,sqscut,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs2-m(4)
       call mapbkk(imom,x(1),q1,mrho,gmrh,sqsl1,sqsu1,s1,sqs1,ds1)
       end if
       if (ikin == 197) then
       sqsu3=ecm-m(3)
       call mapbkk(imom,x(3),q3,mrho,gmrh,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(5)
       call mapakk(imom,x(2),q2,sqscut,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs2-m(4)
       call mapbkk(imom,x(1),q1,mrho,gmrh,sqsl1,sqsu1,s1,sqs1,ds1)
       end if
       call kinff(imom,sqs1,m(6),m(7),x(4:5),p(:,6),p(:,7),dl1)
       call kinff(imom,sqs2,m(4),sqs1,x(6:7),p(:,4),q1,dl2)
       call kinff(imom,sqs3,sqs2,m(5),x(8:9),q2,p(:,5),dl3)
       call kinff(imom,ecm,m(3),sqs3,x(10:11),p(:,3),q3,dlips)
       dlips=dlips*ds1*ds2*ds3
     &            *dl1*dl2*dl3
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,6))
        call boost(g,v,p(:,7))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,6))
        call boost(g,v,p(:,7))
        v=q3(1:)/q3(0)
        g=q3(0)/sqs3
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,6))
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,5))
       end if
      else if (ikin <= nt101) then
       sqsl1=m(3)+m(7)
       sqsl2=m(5)+m(6)
       sqsl3=m(4)+sqsl2
       if (imom /= 1) then
        q1=p(:,3)+p(:,7)
        q2=p(:,5)+p(:,6)
        q3=p(:,4)+q2
       end if
       if (ikin == 198) then
       sqsu1=ecm-sqsl3
       call mapbkk(imom,x(1),q1,mpi,zero,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu3=ecm-sqs1
       call mapbkk(imom,x(3),q3,mpi,zero,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(4)
       call mapakk(imom,x(2),q2,sqscut,sqsl2,sqsu2,s2,sqs2,ds2)
       end if
       if (ikin == 199) then
       sqsu1=ecm-sqsl3
       call mapbkk(imom,x(1),q1,mpi,zero,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu3=ecm-sqs1
       call mapbkk(imom,x(3),q3,mpi,zero,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(4)
       call mapbkk(imom,x(2),q2,mrho,gmrh,sqsl2,sqsu2,s2,sqs2,ds2)
       end if
       if (ikin == 200) then
       sqsu1=ecm-sqsl3
       call mapbkk(imom,x(1),q1,mrho,gmrh,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu3=ecm-sqs1
       call mapbkk(imom,x(3),q3,mrho,gmrh,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(4)
       call mapakk(imom,x(2),q2,sqscut,sqsl2,sqsu2,s2,sqs2,ds2)
       end if
       call kinff(imom,sqs1,m(3),m(7),x(4:5),p(:,3),p(:,7),dl1)
       call kinff(imom,sqs2,m(5),m(6),x(6:7),p(:,5),p(:,6),dl2)
       call kinff(imom,sqs3,m(4),sqs2,x(8:9),p(:,4),q2,dl3)
       call kinff(imom,ecm,sqs1,sqs3,x(10:11),q1,q3,dlips)
       dlips=dlips*ds1*ds2*ds3
     &            *dl1*dl2*dl3
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,7))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,5))
        call boost(g,v,p(:,6))
        v=q3(1:)/q3(0)
        g=q3(0)/sqs3
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,5))
        call boost(g,v,p(:,6))
       end if
      else if (ikin <= nt103) then
       sqsl1=m(5)+m(7)
       sqsl2=sqsl1+m(6)
       sqsl3=m(4)+sqsl2
       if (imom /= 1) then
        q1=p(:,5)+p(:,7)
        q2=q1+p(:,6)
        q3=p(:,4)+q2
       end if
       if (ikin == 201) then
       sqsu3=ecm-m(3)
       call mapbkk(imom,x(3),q3,mpi,zero,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(4)
       call mapakk(imom,x(2),q2,sqscut,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs2-m(6)
       call mapbkk(imom,x(1),q1,mpi,zero,sqsl1,sqsu1,s1,sqs1,ds1)
       end if
       if (ikin == 202) then
       sqsu3=ecm-m(3)
       call mapbkk(imom,x(3),q3,mpi,zero,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(4)
       call mapbkk(imom,x(2),q2,mrho,gmrh,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs2-m(6)
       call mapbkk(imom,x(1),q1,mpi,zero,sqsl1,sqsu1,s1,sqs1,ds1)
       end if
       if (ikin == 203) then
       sqsu3=ecm-m(3)
       call mapbkk(imom,x(3),q3,mrho,gmrh,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(4)
       call mapakk(imom,x(2),q2,sqscut,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs2-m(6)
       call mapbkk(imom,x(1),q1,mpi,zero,sqsl1,sqsu1,s1,sqs1,ds1)
       end if
       call kinff(imom,sqs1,m(5),m(7),x(4:5),p(:,5),p(:,7),dl1)
       call kinff(imom,sqs2,sqs1,m(6),x(6:7),q1,p(:,6),dl2)
       call kinff(imom,sqs3,m(4),sqs2,x(8:9),p(:,4),q2,dl3)
       call kinff(imom,ecm,m(3),sqs3,x(10:11),p(:,3),q3,dlips)
       dlips=dlips*ds1*ds2*ds3
     &            *dl1*dl2*dl3
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,5))
        call boost(g,v,p(:,7))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,5))
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,6))
        v=q3(1:)/q3(0)
        g=q3(0)/sqs3
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,5))
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,6))
       end if
      else if (ikin <= nt104) then
       sqsl1=m(6)+m(7)
       sqsl2=m(5)+sqsl1
       sqsl3=m(4)+sqsl2
       if (imom /= 1) then
        q1=p(:,6)+p(:,7)
        q2=p(:,5)+q1
        q3=p(:,4)+q2
       end if
       if (ikin == 204) then
       sqsu3=ecm-m(3)
       call mapbkk(imom,x(3),q3,mpi,zero,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(4)
       call mapakk(imom,x(2),q2,sqscut,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs2-m(5)
       call mapbkk(imom,x(1),q1,mpi,zero,sqsl1,sqsu1,s1,sqs1,ds1)
       end if
       if (ikin == 205) then
       sqsu3=ecm-m(3)
       call mapbkk(imom,x(3),q3,mpi,zero,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(4)
       call mapbkk(imom,x(2),q2,mrho,gmrh,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs2-m(5)
       call mapbkk(imom,x(1),q1,mpi,zero,sqsl1,sqsu1,s1,sqs1,ds1)
       end if
       if (ikin == 206) then
       sqsu3=ecm-m(3)
       call mapbkk(imom,x(3),q3,mrho,gmrh,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(4)
       call mapakk(imom,x(2),q2,sqscut,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs2-m(5)
       call mapbkk(imom,x(1),q1,mpi,zero,sqsl1,sqsu1,s1,sqs1,ds1)
       end if
       call kinff(imom,sqs1,m(6),m(7),x(4:5),p(:,6),p(:,7),dl1)
       call kinff(imom,sqs2,m(5),sqs1,x(6:7),p(:,5),q1,dl2)
       call kinff(imom,sqs3,m(4),sqs2,x(8:9),p(:,4),q2,dl3)
       call kinff(imom,ecm,m(3),sqs3,x(10:11),p(:,3),q3,dlips)
       dlips=dlips*ds1*ds2*ds3
     &            *dl1*dl2*dl3
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,6))
        call boost(g,v,p(:,7))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,5))
        call boost(g,v,p(:,6))
        call boost(g,v,p(:,7))
        v=q3(1:)/q3(0)
        g=q3(0)/sqs3
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,5))
        call boost(g,v,p(:,6))
        call boost(g,v,p(:,7))
       end if
      end if
 
      end
