      function lamsq(x,y,z)
c----------------------------------------------------------------------c
c The kinematic lambda function, with sqrt(x),sqrt(y),sqrt(z) as 
c arguments instead of x,y,z
c----------------------------------------------------------------------c

      integer, parameter :: dp=kind(1.d0)
      real(dp) :: lamsq,x,y,z

      lamsq=(x-y-z)*(x+y+z)*(x-y+z)*(x+y-z)

      if (lamsq < 0.d0) then
         lamsq=0.d0
      end if

      end function


