      subroutine gamtopan(x)
c----------------------------------------------------------------------c
c The unpolarized top and antitop quark width in the presence of 
c the anomalous Wtb coupling
c
c Input:  x(2) - random numbers
c
c Karol Kolodziej, University of Silesia, kolodzie@us.edu.pl
c 13 October, 2001;  modified on 16 January, 2003,
c 27 Jan., 2011: adjusted to be used in carlomat
c----------------------------------------------------------------------c

      use drivekk
      use inprms 
      use couplsmkk
      use topan

      implicit none

      real(dp) :: x(2)
      real(dp), dimension(0:3) :: p1,p2,p3
      real(dp) :: dlips,mat2,mat2b

      call kintwb(mt,mw,mb,x,p1,p2,p3,dlips)

      call twbxx(p1,p2,p3,mat2,mat2b)

      gamt=mat2/(2.d0*mt)*dlips/(2.d0*pi)**2

      if (iwtb == 2) then
       gmtb=mat2b/(2.d0*mt)*dlips/(2.d0*pi)**2
      else
       gmtb=gamt
      end if

      end


